<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Auth_db Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>Auth_db Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3><div class="affiliation"><span class="orgname">FhG Fokus<br></span></div><code class="email">&lt;<a class="email" href="mailto:jan@iptel.org">jan@iptel.org</a>&gt;</code></div><div class="author"><h3 class="author"><span class="firstname">Jakob</span> <span class="surname">Schlyter</span></h3><code class="email">&lt;<a class="email" href="mailto:jakob@schlyter.se">jakob@schlyter.se</a>&gt;</code></div><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3><code class="email">&lt;<a class="email" href="mailto:bogdan@opensips.org">bogdan@opensips.org</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3><code class="email">&lt;<a class="email" href="mailto:jan@iptel.org">jan@iptel.org</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2002, 2003 FhG FOKUS</p></div><div><p class="copyright">Copyright © 2005 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id270249">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id274689">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id273357">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id275662">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248026">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249071">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248831">1.3.1. <code class="varname">db_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id249641">1.3.2. <code class="varname">user_column</code> (string)</a></span></dt><dt><span class="section"><a href="#id249676">1.3.3. <code class="varname">domain_column</code> (string)</a></span></dt><dt><span class="section"><a href="#id293400">1.3.4. <code class="varname">password_column</code> (string)</a></span></dt><dt><span class="section"><a href="#id293435">1.3.5. <code class="varname">password_column_2</code> (string)</a></span></dt><dt><span class="section"><a href="#id293470">1.3.6. <code class="varname">calculate_ha1</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293537">1.3.7. <code class="varname">use_domain</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293580">1.3.8. <code class="varname">load_credentials</code> (string)</a></span></dt><dt><span class="section"><a href="#id293638">1.3.9. <code class="varname">skip_version_check</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293673">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293678">1.4.1. 
			<code class="function">www_authorize(realm, table)</code>
		</a></span></dt><dt><span class="section"><a href="#id293807">1.4.2. 
			<code class="function">proxy_authorize(realm, table)</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248853"><code class="varname">db_url</code> parameter usage</a></dt><dt>1.2. <a href="#id249661"><code class="varname">user_column</code> parameter usage</a></dt><dt>1.3. <a href="#id249696"><code class="varname">domain_column</code> parameter usage</a></dt><dt>1.4. <a href="#id293420"><code class="varname">password_column</code> parameter usage</a></dt><dt>1.5. <a href="#id293455"><code class="varname">password_column_2</code> parameter usage</a></dt><dt>1.6. <a href="#id293522"><code class="varname">calculate_ha1</code> parameter usage</a></dt><dt>1.7. <a href="#id293565"><code class="varname">use_domain</code> parameter usage</a></dt><dt>1.8. <a href="#id293622"><code class="varname">load_credentials</code> parameter usage</a></dt><dt>1.9. <a href="#id293657"><code class="varname">skip_version_check</code> parameter usage</a></dt><dt>1.10. <a href="#id293789"><code class="function">www_authorize</code> usage</a></dt><dt>1.11. <a href="#id293916">proxy_authorize usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id270249"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id274689"></a>1.1. Overview</h2></div></div></div><p>
		This module contains all authentication related functions that need 
		the access to the database. This module should be used together with 
		auth module, it cannot be used independently because it depends on 
		the module. Select this module if you want to use database to store 
		authentication information like subscriber usernames and passwords. If
		you want to use radius authentication, then use auth_radius instead.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id273357"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id275662"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
			The module depends on the following modules (in the other words 
			the listed modules must be loaded before this module):
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>auth</em></span> -- Generic authentication 
				functions
				</p></li><li><p><span class="emphasis"><em>database</em></span> -- Any database module
				(currently mysql, postgres, dbtext)
				</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248026"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
			The following libraries or applications must be installed 
			before running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>none</em></span></p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249071"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248831"></a>1.3.1. <code class="varname">db_url</code> (string)</h3></div></div></div><p>
		This is URL of the database to be used. Value of the parameter depends 
		on the database module used. For example for mysql and postgres modules 
		this is something like mysql://username:password@host:port/database. 
		For dbtext module (which stores data in plaintext files) it is
		directory in which the database resides.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">mysql://opensipsro:opensipsro@localhost/opensips</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248853"></a><p class="title"><b>Example 1.1. <code class="varname">db_url</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("auth_db", "db_url", "dbdriver://username:password@dbhost/dbname")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249641"></a>1.3.2. <code class="varname">user_column</code> (string)</h3></div></div></div><p>
		This is the name of the column holding usernames. Default value is 
		fine for most people. Use the parameter if you really need to change it.
		</p><p>
		Default value is &#8220;<span class="quote">username</span>&#8221;.
		</p><div class="example"><a name="id249661"></a><p class="title"><b>Example 1.2. <code class="varname">user_column</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("auth_db", "user_column", "user")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249676"></a>1.3.3. <code class="varname">domain_column</code> (string)</h3></div></div></div><p>
		This is the name of the column holding domains of users. Default value 
		is fine for most people. Use the parameter if you really need to 
		change it.
		</p><p>
		Default value is &#8220;<span class="quote">domain</span>&#8221;.
		</p><div class="example"><a name="id249696"></a><p class="title"><b>Example 1.3. <code class="varname">domain_column</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("auth_db", "domain_column", "domain")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293400"></a>1.3.4. <code class="varname">password_column</code> (string)</h3></div></div></div><p>
		This is the name of the column holding passwords. Passwords can be 
		either stored as plain text or pre-calculated HA1 strings. HA1 strings 
		are MD5 hashes of username, password, and realm. HA1 strings are more 
		safe because the server doesn't need to know plaintext passwords and 
		they cannot be obtained from HA1 strings.
		</p><p>
		Default value is &#8220;<span class="quote">ha1</span>&#8221;.
		</p><div class="example"><a name="id293420"></a><p class="title"><b>Example 1.4. <code class="varname">password_column</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("auth_db", "password_column", "password")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293435"></a>1.3.5. <code class="varname">password_column_2</code> (string)</h3></div></div></div><p>
		As described in the previous section this parameter contains name of 
		column holding pre-calculated HA1 string that were calculated including 
		the domain in the username. This parameter is used only when 
		<code class="varname">calculate_ha1</code> is set to 0 and user agent send a 
		credentials containing the domain in the username.
		</p><p>
		Default value of the parameter is ha1b.
		</p><div class="example"><a name="id293455"></a><p class="title"><b>Example 1.5. <code class="varname">password_column_2</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("auth_db", "password_column_2", "ha1_2")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293470"></a>1.3.6. <code class="varname">calculate_ha1</code> (integer)</h3></div></div></div><p>
		This parameter tells the server whether it should use plaintext 
		passwords or a pre-calculated HA1 string for authentification.
		</p><p>
		If the parameter is set to 1 and the username parameter of credentials
		contains also &#8220;<span class="quote">@domain</span>&#8221; (some user agents append the
		domain to the username parameter), then the server will use the HA1
		values from the column specified in the 
		&#8220;<span class="quote">password_column_2</span>&#8221; parameter. If the username parameter
		doesn't contain a domain, the server will use the HA1 values from the
		column given in the &#8220;<span class="quote">password_column</span>&#8221;parameter.
		</p><p>
		If the parameter is set to 0 then the HA1 value will be calculated
		from the column specified in the &#8220;<span class="quote">password_column</span>&#8221;
		parameter.
		</p><p>
		The &#8220;<span class="quote">password_column_2</span>&#8221; column contains also HA1 strings
		but they should be calculated including the domain in the username
		parameter (as opposed to password_column which (when containing HA1
		strings) should always contain HA1 strings calculated without domain
		in username.
		</p><p>
		This ensures that the authentication will always work when using
		pre-calculated HA1 strings, not depending on the presence of the
		domain in username.
		</p><p>
		Default value of this parameter is 0.
		</p><div class="example"><a name="id293522"></a><p class="title"><b>Example 1.6. <code class="varname">calculate_ha1</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("auth_db", "calculate_ha1", 1)
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293537"></a>1.3.7. <code class="varname">use_domain</code> (integer)</h3></div></div></div><p>
		If true (not 0), domain will be also used when looking up in the 
		subscriber table. If you have a multi-domain setup, it is strongly
		recommended to turn on this parameter to avoid username overlapping
		between domains.
		</p><p>
		IMPORTANT: before turning on this parameter, be sure that the 
		<code class="varname">domain</code> column in <code class="varname">subscriber</code> 
		table is properly populated.
		</p><p>
		Default value is &#8220;<span class="quote">0 (false)</span>&#8221;.
		</p><div class="example"><a name="id293565"></a><p class="title"><b>Example 1.7. <code class="varname">use_domain</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("auth_db", "use_domain", 1)
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293580"></a>1.3.8. <code class="varname">load_credentials</code> (string)</h3></div></div></div><p>
		This parameter specifies credentials to be fetched from database when
		the authentication is performed. The loaded credentials will be stored
		in AVPs. If the AVP name is not specificaly given, it will be used a
		NAME AVP with the same name as the column name.
		</p><p>
		 Parameter syntax:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>
			load_credentials = credential (';' credential)*
			</em></span></p></li><li><p><span class="emphasis"><em>
			credential = (avp_specification '=' column_name) |
							(column_name)
			</em></span></p></li><li><p><span class="emphasis"><em>
			avp_specification = '$avp(' + NAME + ')'
			</em></span></p></li></ul></div><p>
		</p><p>
		Default value of this parameter is &#8220;<span class="quote">rpid</span>&#8221;.
		</p><div class="example"><a name="id293622"></a><p class="title"><b>Example 1.8. <code class="varname">load_credentials</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
# load rpid column into $avp(13) and email_address column
# into $avp(email_address)
modparam("auth_db", "load_credentials", "$avp(13)=rpid;email_address")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293638"></a>1.3.9. <code class="varname">skip_version_check</code> (int)</h3></div></div></div><p>
		This parameter specifies not to check the auth table version. This
		parameter should be set when a custom authentication table is used.
		</p><p>
		Default value is &#8220;<span class="quote">0 (false)</span>&#8221;.
		</p><div class="example"><a name="id293657"></a><p class="title"><b>Example 1.9. <code class="varname">skip_version_check</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("auth_db", "skip_version_check", 1)
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293673"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293678"></a>1.4.1. 
			<code class="function">www_authorize(realm, table)</code>
		</h3></div></div></div><p>
		The function verifies credentials according to 
		<a class="ulink" href="http://www.ietf.org/rfc/rfc2617.txt" target="_top">RFC2617</a>. If the 
		credentials are verified successfully then the function will succeed 
		and mark the credentials as authorized (marked credentials can be later 
		used by some other functions). If the function was unable to verify the 
		credentials for some reason then it will fail and the script should 
		call <code class="function">www_challenge</code> which will 
		challenge the user again.
		</p><p>Negative codes may be interpreted as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>-5 (generic error)</em></span> - some generic error
			occurred and no reply was sent out;
			</p></li><li><p>
			<span class="emphasis"><em>-4 (no credentials)</em></span> - credentials were not
			found in request;
			</p></li><li><p>
			<span class="emphasis"><em>-3 (stale nonce)</em></span> - stale nonce;
			</p></li><li><p>
			<span class="emphasis"><em>-2 (invalid password)</em></span> - valid user, but 
			wrong password;
			</p></li><li><p>
			<span class="emphasis"><em>-1 (invalid user)</em></span> - authentication user does
			not exist.
			</p></li></ul></div><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>realm</em></span> - Realm is an opaque string that 
			the user agent should present to the user so it can decide what 
			username and password to use. Usually this is domain of the host 
			the server is running on.
			</p><p>
			If an empty string &#8220;<span class="quote"></span>&#8221; is used then the server will 
			generate it from the request. In case of REGISTER requests To 
			header field domain will be used (because this header field 
			represents a user being registered), for all other messages From 
			header field domain will be used.
			</p><p>
			The string may contain pseudo variables.
			</p></li><li><p><span class="emphasis"><em>table</em></span> - Table to be used to lookup 
			usernames and passwords (usually subscribers table).
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293789"></a><p class="title"><b>Example 1.10. <code class="function">www_authorize</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (www_authorize("siphub.net", "subscriber")) {
	www_challenge("siphub.net", "1");
};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293807"></a>1.4.2. 
			<code class="function">proxy_authorize(realm, table)</code>
		</h3></div></div></div><p>
		The function verifies credentials according to 
		<a class="ulink" href="http://www.ietf.org/rfc/rfc2617.txt" target="_top">RFC2617</a>. If 
		the credentials are verified successfully then the function will 
		succeed and mark the credentials as authorized (marked credentials can 
		be later used by some other functions). If the function was unable to 
		verify the credentials for some reason then it will fail and
		the script should call 
		<code class="function">proxy_challenge</code> which will
		challenge the user again. 
		</p><p>Negative codes may be interpreted as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
					<span class="emphasis"><em>-5 (generic error)</em></span> - some generic error
					occurred and no reply was sent out;
				</p></li><li><p>
					<span class="emphasis"><em>-4 (no credentials)</em></span> - credentials were not
					found in request;
				</p></li><li><p>
					<span class="emphasis"><em>-3 (stale nonce)</em></span> - stale nonce;
				</p></li><li><p>
					<span class="emphasis"><em>-2 (invalid password)</em></span> - valid user, but 
					wrong password;
				</p></li><li><p>
					<span class="emphasis"><em>-1 (invalid user)</em></span> - authentication user does
					not exist.
				</p></li></ul></div><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>realm</em></span> - Realm is an opaque string that 
			the user agent should present to the user so it can decide what 
			username and password to use. Usually this is domain of the host 
			the server is running on.
			</p><p>
			If an empty string &#8220;<span class="quote"></span>&#8221; is used then the server will 
			generate it from the request. From header field domain will be 
			used as realm.
			</p><p>
			The string may contain pseudo variables.
			</p></li><li><p><span class="emphasis"><em>table</em></span> - Table to be used to lookup 
			usernames and passwords (usually subscribers table).
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293916"></a><p class="title"><b>Example 1.11. proxy_authorize usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (!proxy_authorize("", "subscriber)) {
	proxy_challenge("", "1");  # Realm will be autogenerated
};
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
